<?php


function _ntm_m_get_names() {
  $names = menu_get_menus();
  return $names;
}


function _ntm_t_get_names() {
  $options = taxonomy_vocabulary_get_names();
  foreach ($options as $item) {
    $names[$item->vid] = $item->name;
  }
  return $names;
}


function _ntm_m_get_tree($source_id) {
  $cache = &drupal_static('ntm_menu_cache', array());
  if (!isset($cache[$source_id])) {
    $cache[$source_id] = menu_build_tree($source_id);
  }
  return $cache[$source_id];
}


function _ntm_t_get_tree($source_id) {
  $tree = taxonomy_get_tree($source_id);
  foreach ($tree as $node) {
    $node->depth++;
    $node->iid = $node->tid;
  }
  return $tree;
}


function _ntm_m_get_sub_tree($tree, $iid) {
  foreach ($tree as $node) {
    if ($node['link'] && $node['link']['mlid'] == $iid) return $node;
    if ($node['below']) {
      $node = _ntm_m_get_sub_tree($node['below'], $iid);
      if ($node) return $node;
    }
  }
}


function _ntm_m_items_collect($tree, &$info = array()) {
  foreach ($tree as $node) {
    $link = $node['link'];
    if ($link && $link['type'] == MENU_NORMAL_ITEM) {
      $info[]= (object)array('iid' => $link['mlid'], 'name' => $link['title'], 'depth' => $link['depth']);
    }
    if ($node['below']) {
      _ntm_m_items_collect($node['below'], $info);
    }
  }
  return $info;
}


function _ntm_t_items_collect($tree) {
  return $tree;
}


function _ntm_m_fix_class(&$tree) {
  foreach ($tree as &$node) {
    if (isset($node['#attributes']['class'])) {
      if (isset($node['#below']) && count($node['#below'])) {
        $node['#attributes']['class'][]= 'has_child';
      }
    }
    if (isset($node['#below'])) {
      _ntm_m_fix_class($node['#below']);
    }
  }
}


function _ntm_m_tree_render($tree, $style = 'down') {
  $tree = menu_tree_output($tree);
  _ntm_m_fix_class($tree);
  return '<div class="menu-ntm menu-ntm-'.$style.'">'.drupal_render($tree).'</div>';
}

